﻿using System;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace WindowsFormsApplication1
{
    public class DBWrapper
    {
        SqlConnection dbConn;

        String userName = "aref08";
        String password = "aref08";
        String server = "10.0.0.13";
        String trustedConnection = "no";
        String database = "MVP";
        String connTimeOut = "30";

        Boolean debug = false;

        public void debugOn() { debug = true; }
        public void debugOff() { debug = false; }

        public DBWrapper()
        {
            debugOff();
        }

        public DBWrapper(Boolean debug)
        {
            if (debug)
                debugOn();
            else
                debugOff();
        }

        public void openConnection()
        {
            dbConn = new SqlConnection(buildConnString(userName, password, server, trustedConnection, database, connTimeOut));

            try
            {
                dbConn.Open();
            }
            catch (Exception e)
            {
                MessageBox.Show("Error opening DB Connection:\n" + e.ToString());
            }

        }

        public void openConnection(String srvr)
        {
            dbConn = new SqlConnection(buildConnString(userName, password, srvr, trustedConnection, database, connTimeOut));

            try
            {
                dbConn.Open();
                if (debug)
                    MessageBox.Show("DB Opened Successfully.");
            }
            catch (Exception e)
            {
                if (debug)
                    MessageBox.Show("Error opening DB Connection:\n" + e.ToString());
            }
        }

        public void openConnection(String uN, String pass, String srvr, String trustConn, String dB, String connTime)
        {
            dbConn = new SqlConnection(buildConnString(uN, pass, srvr, trustConn, dB, connTime));

            try
            {
                dbConn.Open();
                if (debug)
                    MessageBox.Show("DB Opened Successfully.");
            }
            catch (Exception e)
            {
                if (debug)
                    MessageBox.Show("Error opening DB Connection:\n" + e.ToString());
            }
        }

        private String buildConnString(String uN, String pass, String server, String tC, String dB, String connTO)
        {
            String connString = "";
            connString += "user id=" + uN + ";";
            connString += "password=" + pass + ";";
            connString += "server=" + server + ";";
            connString += "Trusted_Connection=" + tC + ";";
            connString += "database=" + dB + ";";
            connString += "connection timeout=" + connTO + ";";
            return connString;
        }

        //getAllTables() IS FOR MY DEMO TABLE ONLY. DO NOT USE IT FOR REAL IMPLEMENTAIONS
        public DataSet getAllTables()
        {
            String sqlCommand = "";
            sqlCommand += "SELECT * FROM ATTEND;";
            sqlCommand += "SELECT * FROM DISTRIBUTED_ROOM;";
            sqlCommand += "SELECT * FROM EQUIPMENT;";
            sqlCommand += "SELECT * FROM EQUIPMENT_BOOKED;";
            sqlCommand += "SELECT * FROM EXCLUSION_TIME_SET;";
            sqlCommand += "SELECT * FROM MEETING;";
            sqlCommand += "SELECT * FROM PHYSICAL_ROOM;";
            sqlCommand += "SELECT * FROM PREFERENCE_TIME_SET;";
            sqlCommand += "SELECT * FROM ROOM;";
            sqlCommand += "SELECT * FROM ROOM_BOOKED;";
            sqlCommand += "SELECT * FROM USERS;";

            DataSet dSMVP = new DataSet();
            SqlDataAdapter dA = new SqlDataAdapter(sqlCommand, dbConn);
            dA.TableMappings.Add("Table", "ATTEND");
            dA.TableMappings.Add("Table1", "DISTRIBUTED_ROOM");
            dA.TableMappings.Add("Table2", "EQUIPMENT");
            dA.TableMappings.Add("Table3", "EQUIPMENT_BOOKED");
            dA.TableMappings.Add("Table4", "EXCLUSION_TIME_SET");
            dA.TableMappings.Add("Table5", "MEETING");
            dA.TableMappings.Add("Table6", "PHYSICAL_ROOM");
            dA.TableMappings.Add("Table7", "PREFERENCE_TIME_SET");
            dA.TableMappings.Add("Table8", "ROOM");
            dA.TableMappings.Add("Table9", "ROOM_BOOKED");
            dA.TableMappings.Add("Table10", "USERS");

            dA.Fill(dSMVP);
            return dSMVP;
        }

        public DataTable getMeetings()
        {
            SqlDataAdapter dA = new SqlDataAdapter("SELECT * FROM MEETING", dbConn);
            DataTable meetingTable = new DataTable();
            dA.Fill(meetingTable);
            return meetingTable;
        }

        public user getUser(int userID)
        {
            //Our SQL Query returns a table of data, so we need a place to put it.
            DataTable dT = new DataTable();
            //The SQL Data Adapter connects, transmits the query, gets the result, and then disconnects.
            SqlDataAdapter dA = new SqlDataAdapter("SELECT * FROM USERS WHERE U_ID = " + userID, dbConn);
            //Fill transfers the results into the Datatable DT
            dA.Fill(dT);
            //Now we want a single row off the table. This is stored in a DataRow. Notice how the rows in the table can be accessed like an array.
            DataRow userRow = dT.Rows[0];
            //a new user object is built by handing the data row to the constructor. NOTE YOU MUST PROVIDE ALL THE COLUMNS. THIS MEANS USE SELECT * ONLY AND NO TABLE JOINING.
            user newUser = new user(userRow);
            //hand back the new user.
            return newUser;
        }

        public user getUser(String uName)
        {
            DataTable dT = new DataTable();
            SqlDataAdapter dA = new SqlDataAdapter("SELECT * FROM USERS WHERE username = " + uName, dbConn);
            dA.Fill(dT);
            DataRow userRow = dT.Rows[0];
            user newUser = new user(userRow);
            return newUser;
        }

    }
}